"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assignableTypePairs = exports.typeSymbolName = exports.createRule = void 0;
/* eslint-disable total-functions/no-unsafe-readonly-mutable-assignment */
/* eslint-disable functional/prefer-immutable-types */
const utils_1 = require("@typescript-eslint/utils");
const tsutils_1 = require("tsutils");
exports.createRule = utils_1.ESLintUtils.RuleCreator(
// eslint-disable-next-line functional/functional-parameters
() => "https://github.com/danielnixon/eslint-plugin-total-functions");
const typeSymbolName = (type) => {
    // eslint-disable-next-line functional/no-try-statements
    try {
        // HACK despite what the type suggests, symbol can in fact be undefined
        // eslint-disable-next-line @typescript-eslint/no-unnecessary-condition
        return type?.symbol?.name;
    }
    catch {
        // Accessing symbol can throw for reasons I don't fully understand.
        return undefined;
    }
};
exports.typeSymbolName = typeSymbolName;
/**
 * Breaks the supplied types into their union type parts and returns an
 * array of pairs of constituent types that are assignable.
 */
const assignableTypePairs = (rawDestinationType, rawSourceType, checker) => {
    const destinationTypeParts = (0, tsutils_1.unionTypeParts)(rawDestinationType);
    const sourceTypeParts = (0, tsutils_1.unionTypeParts)(rawSourceType);
    return sourceTypeParts.flatMap((sourceTypePart) => destinationTypeParts
        .filter((destinationTypePart) => checker.isTypeAssignableTo(sourceTypePart, destinationTypePart))
        .map((destinationTypePart) => ({
        sourceType: sourceTypePart,
        destinationType: destinationTypePart,
    })));
};
exports.assignableTypePairs = assignableTypePairs;
